' routine to receive DHCP information from the DHCP-server
'
'
'
'
'*******************************  DHCP-discover  *******************************

Sub Send_dhcp_discover
   Call Clearbuff                                           'Clear the complete buffer

   'Mac-header =============

   Buffer(1) = &HFF                                         'destination MAC address
   Buffer(2) = &HFF
   Buffer(3) = &HFF
   Buffer(4) = &HFF
   Buffer(5) = &HFF
   Buffer(6) = &HFF

   Call Src2mymac                                           'MAC source address

   Buffer(13) = &H08                                        'DOD IP
   Buffer(14) = &H00

   'IP-header ==============

   Buffer(15) = &H45                                        'header length
   Buffer(16) = &H00                                        'Type of service

   Buffer(17) = &H01                                        'total length
   Buffer(18) = &H16

   Buffer(19) = &H05                                        'IDentification
   Buffer(20) = &H0D

   Buffer(21) = &H00                                        'flags --> not fragmented

   Buffer(22) = &H00                                        'fragment offset

   Buffer(23) = &H80                                        'TTL

   Buffer(24) = Prot_udp                                    'protocol UDP

   '25 is checksum
   '26 is checksum

   T_ip_srcaddr = 0                                         'source address  --> 0.0.0.0

   T_ip_destaddr = &HFFFFFFFF                               'destination IP --> 255.255.255.255

   Buffer(35) = &H00                                        'source port 68 -->DHCP client
   Buffer(36) = &H44
   Buffer(37) = &H00                                        'destination port 67 --> DHCP server
   Buffer(38) = &H43
   Buffer(39) = &H01                                        'length
   Buffer(40) = &H02

   '41 is checksum
   '42 is checksum

   'DHCP
   Buffer(43) = &H01                                        'Dhcp_pack_request
   Buffer(44) = &H01                                        'Dhcp_htype10mb  &H02 --> 100mb
   Buffer(45) = &H06                                        'mac-address length
   Buffer(46) = &H00                                        'Dhcp_hops

   'fixed
   Buffer(47) = &H1F                                        'transaction ID
   Buffer(48) = &H45
   Buffer(49) = &H3A
   Buffer(50) = &HDE


   Buffer(53) = &H80                                        'Broadcast flag
   Buffer(54) = &H00

'Buffer 55-58 = ClientIP
'Buffer 59-62 = ClientIP
'Buffer 63-66 = Next Server IP
'Buffer 67-70 = RelayAgentIP

   Buffer(71) = Mymac(1)
   Buffer(72) = Mymac(2)
   Buffer(73) = Mymac(3)                                    'MAC source address
   Buffer(74) = Mymac(4)
   Buffer(75) = Mymac(5)
   Buffer(76) = Mymac(6)

   Buffer(279) = &H63                                       'DHCP cookie
   Buffer(280) = &H82
   Buffer(281) = &H53
   Buffer(282) = &H63

   Buffer(283) = &H37                                       'option 55: request parameters
   Buffer(284) = &H03                                       'length=3
   Buffer(285) = &H01                                       'Subnetmask
   Buffer(286) = &H03                                       'Router
   Buffer(287) = &H06                                       'Dns

   Buffer(288) = &H35                                       'options 53: DHCP Discover
   Buffer(289) = &H01                                       'length=1
   Buffer(290) = &H01                                       'Dhcp_discover

   Buffer(291) = &HFF                                       'end

   Call Ip_header_checksum
   Call Udp_checksum
   Call Echopacket
End Sub

'*************************** DHCP-packet filter ********************************

Sub Dhcp
  If Buffer(43) = &H02 Then                                 '2 boot reply
     If Buffer(47) = &H1F Then                              '31 transaction ID
        If Buffer(48) = &H45 Then                           '69
           If Buffer(49) = &H3A Then                        '58
              If Buffer(50) = &HDE Then                     '222
                  If Buffer(283) = &H35 Then                'options  53
                     If Buffer(284) = &H01 Then

                        If Buffer(285) = &H02 Then          'Dhcp_offer
                           ' Es wird uns eine IP-Adresse vom Server angeboten
                           Call Dhcp_request
                        End If

                        If Buffer(285) = &H05 Then          'Dhcp_ACK
                           ' Die IP-Adresse wurde vom Server besttigt
                           Call Dhcp_lease
                        End If

                        If Buffer(285) = &H06 Then          'Dhcp_NAK
                           ' Die IP-Adresse wurde vom Server abgewiesen. -> Nochmal versuchen
'                           Call Send_dhcp_discover
                        End If

                     End If
                  End If
              End If
           End If
        End If
     End If
  End If
End Sub


'******************************  DHCP-request  *********************************




Sub Dhcp_request
  Local Temp As Word

  'Mac-header =============

  Call Src2mymac                                            'MAC source address

  Buffer(17) = &H01
  Buffer(18) = &H2B                                         'IPv4 Header lengh


  'IP-header ==============

  T_ip_srcaddr = 0                                          'source address  --> 0.0.0.0

  'UDP Header ========

  Call Swapdestport2srcport                                 'swap souce and destination port  67<-->68

  Buffer(39) = &H01
  Buffer(40) = &H17                                         'UDP Header lengh


  'BOOTP ===============

  Buffer(43) = &H01                                         'Dhcp_pack_request
  Buffer(44) = &H01                                         'Dhcp_htype10mb    ( &H02 --> 100mb )

  Buffer(283) = &H35                                        'option 53: DHCP Discover
  Buffer(284) = &H01                                        'length=1
  Buffer(285) = &H03                                        'Dhcp_request    (07-->DHCP release )

  Buffer(286) = &H32                                        'option 50 --> suggested to wanted IP
  Buffer(287) = &H04                                        'length=4
  Buffer(288) = Buffer(59)                                  'Zugewiesene IP-Adresse
  Buffer(289) = Buffer(60)
  Buffer(290) = Buffer(61)
  Buffer(291) = Buffer(62)

  Buffer(292) = &H36                                        'option 54 --> DHCP-Server-IP-Adresse
  Buffer(293) = &H04                                        'length=4
  Buffer(294) = Buffer(63)                                  'DHCP-Server-Adresse
  Buffer(295) = Buffer(64)
  Buffer(296) = Buffer(65)
  Buffer(297) = Buffer(66)

  Buffer(298) = &H0C                                        'option 12 -->Hostname
  Buffer(299) = &H05                                        'length=5
  Buffer(300) = &H6E                                        'n
  Buffer(301) = &H65                                        'e
  Buffer(302) = &H74                                        't
  Buffer(303) = &H69                                        'i
  Buffer(304) = &H6F                                        'o

  Buffer(305) = &HFF                                        'insert end command

  For Temp = 306 To 400
   Buffer(temp) = &H00
  Next Temp

  Call Ip_header_checksum
  Call Udp_checksum
  Call Echopacket
End Sub


'******************************************************************************

Sub Dhcp_lease
  Myip(1) = Buffer(59)                                      'received ip lease --> my IP
  Myip(2) = Buffer(60)
  Myip(3) = Buffer(61)
  Myip(4) = Buffer(62)

  Lease_time(1) = Buffer(92)                                'lease time
  Lease_time(2) = Buffer(93)
  Lease_time(3) = Buffer(94)
  Lease_time(4) = Buffer(95)
  Lease_time(5) = Buffer(96)
  Lease_time(6) = Buffer(97)

  Subnetmask(1) = Buffer(112)                               'subnetmask
  Subnetmask(2) = Buffer(113)
  Subnetmask(3) = Buffer(114)
  Subnetmask(4) = Buffer(115)

  Broadcast(1) = Buffer(118)                                'broadcast IP
  Broadcast(2) = Buffer(119)
  Broadcast(3) = Buffer(120)
  Broadcast(4) = Buffer(121)

  Mydns(1) = Buffer(124)                                    'received dns server -->my DNS
  Mydns(2) = Buffer(125)
  Mydns(3) = Buffer(126)
  Mydns(4) = Buffer(127)

  Domain_name(1) = Buffer(128)                              'domain name
  Domain_name(2) = Buffer(129)
  Domain_name(3) = Buffer(130)
  Domain_name(4) = Buffer(131)
  Domain_name(5) = Buffer(132)
  Domain_name(6) = Buffer(133)
  Domain_name(7) = Buffer(134)

  Gateway(1) = Buffer(137)                                  'Gate IP
  Gateway(2) = Buffer(138)
  Gateway(3) = Buffer(139)
  Gateway(4) = Buffer(140)

  Router_mac(1) = Buffer(7)                                 'only if DHCP-server == router !!!
  Router_mac(2) = Buffer(8)
  Router_mac(3) = Buffer(9)
  Router_mac(4) = Buffer(10)
  Router_mac(5) = Buffer(11)
  Router_mac(6) = Buffer(12)

  Call Dhcp_received_newip

  Dhcp_flag = 1                                             'to start the NTP
End Sub