'********************************  FUNCTIONS  ********************************
Sub Setdmxch(byval Channel As Word , Byval Startvalue As Byte , Byval Endvalue As Byte , Byval Fadetime As Word)
   Local Steps As Integer
   Local Ftime As Long
   Local Ftemp As Single

   If Channel < 1 Or Channel > Lastchan Then Exit Sub

   If Fadetime = 0 Then
      ' Schalten
      Newdmxfield(channel) = Endvalue
      Dmxfield(channel) = Endvalue
   Else
      ' Dimmen
      Dmxfield(channel) = Startvalue
      ' Minimale Fadezeit ist 1ms/Schritt, also 255ms fr 0..255
      Steps = Startvalue - Endvalue
      Steps = Abs(steps)                                    ' Schritte, die es zu dimmen gilt
      Ftime = Fadetime * 1000
      Ftemp = Ftime / Steps
      Dmxsteps(channel) = Int(ftemp)                        ' Wartezyklen bis nchster Inkrementierungsschritt
      Newdmxfield(channel) = Endvalue
   End If
End Sub

Sub Stepupch(byval Channel As Word)
'   0..64..127..191..255
   Select Case Newdmxfield(channel)
      Case 0 To 63 : Call Setdmxch(channel , Dmxfield(channel) , 64 , Globalfadeintime)
      Case 64 To 126 : Call Setdmxch(channel , Dmxfield(channel) , 127 , Globalfadeintime)
      Case 127 To 190 : Call Setdmxch(channel , Dmxfield(channel) , 191 , Globalfadeintime)
      Case 191 To 255 : Call Setdmxch(channel , Dmxfield(channel) , 255 , Globalfadeintime)
   End Select
End Sub

Sub Stepdownch(byval Channel As Word)
'   0..64..127..191..255
   Select Case Newdmxfield(channel)
      Case 192 To 255 : Call Setdmxch(channel , Dmxfield(channel) , 191 , Globalfadeintime)
      Case 128 To 191 : Call Setdmxch(channel , Dmxfield(channel) , 127 , Globalfadeintime)
      Case 65 To 127 : Call Setdmxch(channel , Dmxfield(channel) , 64 , Globalfadeintime)
      Case 1 To 64 : Call Setdmxch(channel , Dmxfield(channel) , 0 , Globalfadeintime)
   End Select
End Sub

Sub Readtemp
   Local Ar1 As Byte
   Local Ar2 As Byte

   Disable Interrupts                                       ' Interrupts stren bei der 1Wire-Kommunikation

   1wreset
   1wwrite &HCC
   1wwrite &H44
   Waitms 100
   1wreset
   1wwrite &HCC
   1wwrite &HBE
   Ar1 = 1wread()
   Ar2 = 1wread()

   Enable Interrupts                                        ' Interrupts wieder aktivieren
   Udr = 0                                                  ' DMX512-Sender wieder starten

   Temperatur = Ar1
   If Ar2 > 0 Then Temperatur = 0 Else Shift Temperatur , Right
   Halb = Ar1 And 1
   If Halb = 1 Then Halb = 5 Else Halb = 0
End Sub

Sub Readtouch
   Local Col As Byte
   Local Row As Byte

   Config Pina.0 = Output                                   ' Makes port F.0 output
   Config Pina.2 = Output                                   ' Makes port F.0 output
   Set Porta.0                                              ' Sets port F.0 High
   Reset Porta.2                                            ' Sets port F.2 Low
   Ddra.1 = 0                                               ' Sets port F.1 as input
   Ddra.3 = 0                                               ' Sets port F.1 as input because we need it now as ad input
   Waitus 500                                               ' Wait until the port is stable
   Touchx = Getadc(3)                                       ' Read the ad value for the y

   Config Pina.1 = Output                                   ' Makes port F.1 output
   Config Pina.3 = Output                                   ' Makes port F.3 output
   Reset Porta.1                                            ' Sets port F.1 Low
   Set Porta.3                                              ' Sets port F.3 High
   Ddra.0 = 0                                               ' Sets port F.0 as input
   Ddra.2 = 0                                               ' Sets port F.2 as input because we need it now as ad input
   Waitus 500                                               ' Wait until the port is stable
   Touchy = Getadc(2)                                       ' Read the ad value for the x
   Touchy = 1024 - Touchy                                   ' Invert the reading

   ' Touchscreen in Raster aufteilen
   Select Case Touchx
      Case 150 To 300 : Col = 1
      Case 350 To 500 : Col = 2
      Case 550 To 700 : Col = 3
      Case 750 To 900 : Col = 4
      Case Else Col = 0
   End Select

   Select Case Touchy
      Case 200 To 350 : Row = 1
      Case 351 To 500 : Row = 2
      Case 501 To 650 : Row = 3
      Case 651 To 800 : Row = 4
      Case 801 To 1024 : Row = 5
      Case Else Row = 0
   End Select

   If Col > 0 And Row > 0 Then Call Menuaction(col , Row)
End Sub

Sub Proceedrc5
   Select Case Rc5address
      Case 16:
         Select Case Rc5command
            Case 1 To 8 : Currentchannel = Rc5command
            Case 16 : Call Stepupch(currentchannel)
            Case 17 : Call Stepdownch(currentchannel)
         End Select
   End Select
End Sub

Sub Savescene(byval Scene As Byte)
   Select Case Scene
      Case 1:
         Writeeeprom Scenename , Eepscenename1
         Writeeeprom Dmxfield(1) , Eepscene1
      Case 2:
         Writeeeprom Scenename , Eepscenename2
         Writeeeprom Dmxfield(1) , Eepscene2
      Case 3:
         Writeeeprom Scenename , Eepscenename3
         Writeeeprom Dmxfield(1) , Eepscene3
      Case 4:
         Writeeeprom Scenename , Eepscenename4
         Writeeeprom Dmxfield(1) , Eepscene4
      Case 5:
         Writeeeprom Scenename , Eepscenename5
         Writeeeprom Dmxfield(1) , Eepscene5
      Case 6:
         Writeeeprom Scenename , Eepscenename6
         Writeeeprom Dmxfield(1) , Eepscene6
      Case 7:
         Writeeeprom Scenename , Eepscenename7
         Writeeeprom Dmxfield(1) , Eepscene7
      Case 8:
         Writeeeprom Scenename , Eepscenename8
         Writeeeprom Dmxfield(1) , Eepscene8
   End Select

   Writeeeprom Dmxfield(2)
   Writeeeprom Dmxfield(3)
   Writeeeprom Dmxfield(4)
   Writeeeprom Dmxfield(5)
   Writeeeprom Dmxfield(6)
   Writeeeprom Dmxfield(7)
   Writeeeprom Dmxfield(8)
End Sub

Sub Runscene(byval Scene As Byte)
   Select Case Scene
      Case 1 : Readeeprom Scenevalue(1) , Eepscene1
      Case 2 : Readeeprom Scenevalue(1) , Eepscene2
      Case 3 : Readeeprom Scenevalue(1) , Eepscene3
      Case 4 : Readeeprom Scenevalue(1) , Eepscene4
      Case 5 : Readeeprom Scenevalue(1) , Eepscene5
      Case 6 : Readeeprom Scenevalue(1) , Eepscene6
      Case 7 : Readeeprom Scenevalue(1) , Eepscene7
      Case 8 : Readeeprom Scenevalue(1) , Eepscene8
   End Select

   Readeeprom Scenevalue(2)
   Readeeprom Scenevalue(3)
   Readeeprom Scenevalue(4)
   Readeeprom Scenevalue(5)
   Readeeprom Scenevalue(6)
   Readeeprom Scenevalue(7)
   Readeeprom Scenevalue(8)

   For Iw = 1 To Lastchan
      Call Setdmxch(iw , Dmxfield(iw) , Scenevalue(iw) , Globalfadeintime)
   Next Iw
End Sub

Sub Refreshscreen
   #if Rc5debug = 1
      ' RC5-Codes anzeigen
      If Rc5address < 255 Then
         Locate 15 , 1
         Lcd "Letzter RC5-Code: "
         Select Case Rc5address
            Case 15 : Lcd "DVD"
            Case 16 : Lcd "General"
            Case 17 : Lcd "Tuner"
            Case 18 : Lcd "Tape"
            Case 20 : Lcd "CD"
            Case 21 : Lcd "Phono"
            Case 22 : Lcd "DSR/AUX"
            Case 23 : Lcd "DCC"
         End Select
         Lcd " (" ; Rc5address ; ", " ; Rc5command ; ")       "
      End If
   #endif

   Select Case Currentmenu
      Case 0:
         'Hauptmen
         ' Zeit aktualisieren
         Locate 16 , 1
         Lcd Time(l2) ; " " ; Date(l2)
         Locate 16 , 23
         Lcd Temperatur ; "." ; Halb ; "C "

         Locate 15 , 1
         Lcd "Aktueller Kanal: " ; Currentchannel ; " (" ; Newdmxfield(currentchannel) ; ")    "
         Locate 16 , 35
         Lcd Brightness ; "  "
      Case 1:
         'Licht-Men
      Case 3:
         #if Analogclock = 1
            Clocksec = Time(l2)
            Call Drawclock

            Locate 15 , 1
            Lcd Time(l2)
            Locate 16 , 1
            Lcd Date(l2)
            Locate 16 , 36
            Lcd Temperatur ; "." ; Halb ; "C "
         #endif
   End Select
End Sub

Sub Menuaction(byval Col As Byte , Byval Row As Byte)
   Local Percent As Single
   Local Ipercent As Byte

   If Backlight = 0 Then
      Set Backlight                                         ' Hintergrundbeleuchtung einschalten
      Exit Sub
   End If

   If Row = 5 Then                                          'immer zum Ausgangsmen springen
      Currentmenu = 0
      Cls Text
      Showpic 0 , 0 , Mainmenu
   Else
      Select Case Currentmenu
         Case 0:
            ' Hauptmenfunktion gewhlt
            If Col = 1 And Row < 3 Then
               ' Licht-Men
               Currentmenu = 1
               Currentfunction = 1                          ' Kanal 1 vorwhlen
               Cls Text
               Showpic 0 , 0 , Submenu
               Locate 2 , 4
               Lcd "Manuelles Licht"

               Locate 4 , 4
               Lcd "Kanal: " ; Currentfunction
               Percent = Dmxfield(currentfunction) / 2.55
               Ipercent = Round(percent)
               Locate 5 , 4
               Lcd "Aktuell: " ; Ipercent ; "%"
            Elseif Col = 2 And Row < 3 Then
               ' Szenen-Men
               Currentmenu = 2
               Cls Text
               Showpic 0 , 0 , Szenenmenu

               Readeeprom Scenename , Eepscenename1
               Locate 6 , 3 : Lcd Scenename
               Readeeprom Scenename , Eepscenename2
               Locate 6 , 13 : Lcd Scenename
               Readeeprom Scenename , Eepscenename3
               Locate 6 , 23 : Lcd Scenename
               Readeeprom Scenename , Eepscenename4
               Locate 6 , 33 : Lcd Scenename
               Readeeprom Scenename , Eepscenename5
               Locate 13 , 3 : Lcd Scenename
               Readeeprom Scenename , Eepscenename6
               Locate 13 , 13 : Lcd Scenename
               Readeeprom Scenename , Eepscenename7
               Locate 13 , 23 : Lcd Scenename
               Readeeprom Scenename , Eepscenename8
               Locate 13 , 33 : Lcd Scenename
            Elseif Col = 3 And Row < 3 Then
               'Analoguhr
               Currentmenu = 3
               #if Analogclock = 1
                  Clocksec = Time(l2)
                  Cls
                  Call Drawclock
               #endif
            Elseif Col = 4 And Row < 3 Then
               ' Setup-Men
               Currentmenu = 4
               Cls Text
               Showpic 0 , 0 , Submenu
               Locate 2 , 4
               Lcd "Einstellungen"

               #if Network = 1
                  Locate 4 , 4
                  Lcd "IP-Adresse:"
                  Locate 5 , 4
                  Lcd Myip(1) ; "." ; Myip(2) ; "." ; Myip(3) ; "." ; Myip(4)
               #endif

               Locate 8 , 4
               Lcd "Uhrzeit:"
               Locate 9 , 4
               Lcd Time(l2)

               Locate 12 , 4
               Lcd "Datum:"
               Locate 13 , 4
               Lcd Date(l2)
            Elseif Col = 3 And Row > 2 Then
               ' Bluescreen :)
               Currentmenu = 7
               Cls
               Locate 1 , 1
               Lcd "A problem has been detected and Windows"
               Locate 2 , 1
               Lcd "has been shut down to prevent damage"
               Locate 3 , 1
               Lcd "to your computer."
               Locate 5 , 1
               Lcd "A process or thread crucial to system"
               Locate 6 , 1
               Lcd "operation has unexpectedly exited or"
               Locate 7 , 1
               Lcd "been terminated."
               Locate 9 , 1
               Lcd "Technical information:"
               Locate 11 , 1
               Lcd "*** STOP: 0x000000F4 (0x81E99020, 0x805)"
               Locate 13 , 1
               Lcd "Beginning dump of physical memory"
               Locate 14 , 1
               Lcd "Physical memory dump complete."
               Locate 15 , 1
               Lcd "Contact your system administrator."
            Elseif Col = 4 And Row > 2 Then
               ' Info-Screen
               Currentmenu = 7
               Cls Text
               Showpic 0 , 0 , Picstartup
               Locate 1 , 1
               Lcd "AtriumUnum (RoomControl v5.0 Build 0015)"
               Locate 2 , 1
               Lcd "Dipl.-Ing. B.Sc. Chris Noeding"

               Locate 4 , 1
               Lcd "www.pcdimmer.de"

               #if Network = 1
                  Locate 6 , 1
                  Lcd "IP-Adresse:"
                  Locate 7 , 1
                  Lcd Myip(1) ; "." ; Myip(2) ; "." ; Myip(3) ; "." ; Myip(4)

                  Locate 9 , 1
                  Lcd "MAC-Adresse:"
                  Locate 10 , 1
                  Lcd Hex(mymac(1)) ; "-" ; Hex(mymac(2)) ; "-" ; Hex(mymac(3)) ; "-" ; Hex(mymac(4)) ; "-" ; Hex(mymac(5)) ; "-" ; Hex(mymac(6))
               #endif
            End If
         Case 1:
            ' Licht-Men-Funktion gewhlt
            If Col = 3 And Row = 1 Then
               '+
               If Dmxfield(currentfunction) < 255 Then
                  I = Dmxfield(currentfunction) + 1
                  Call Setdmxch(currentfunction , I , I , 0)
               End If
            Elseif Col = 3 And Row = 2 Then
               '-
               If Dmxfield(currentfunction) > 0 Then
                  I = Dmxfield(currentfunction) - 1
                  Call Setdmxch(currentfunction , I , I , 0)
               End If
            Elseif Col = 3 And Row = 3 Then
               '>
               Call Stepupch(currentfunction)
            Elseif Col = 3 And Row = 4 Then
               '<
               Call Stepdownch(currentfunction)
            Elseif Col = 4 And Row < 3 Then
               '^
               If Currentfunction < Lastchan Then
                  Incr Currentfunction
               Else
                  Currentfunction = 1
               End If
            Elseif Col = 4 And Row > 2 Then
               '\/
               If Currentfunction > 1 Then
                  Decr Currentfunction
               Else
                  Currentfunction = Lastchan
               End If
            End If

            Percent = Newdmxfield(currentfunction) / 2.55
            Ipercent = Round(percent)
            Locate 4 , 11
            Lcd Currentfunction ; "  "
            Locate 5 , 13
            Lcd Ipercent ; "%  "
         Case 2:
            ' Szenenmen
            If Col = 1 And Row < 3 Then
               Call Runscene(1)
            Elseif Col = 2 And Row < 3 Then
               Call Runscene(2)
            Elseif Col = 3 And Row < 3 Then
               Call Runscene(3)
            Elseif Col = 4 And Row < 3 Then
               Call Runscene(4)
            Elseif Col = 1 And Row > 2 Then
               Call Runscene(5)
            Elseif Col = 2 And Row > 2 Then
               Call Runscene(6)
            Elseif Col = 3 And Row > 2 Then
               Call Runscene(7)
            Elseif Col = 4 And Row > 2 Then
               Call Runscene(8)
            End If
         Case 4:
            ' Einstellungen
            #if Network = 1
               If Col = 1 And Row = 2 Then
                  Call Send_dhcp_discover                   'DHCP request
               End If
            #endif
      End Select
   End If
End Sub

#if Analogclock = 1
Sub Drawclock
   ' Kreise
   Circle(centrex , Centrey) , Bigradius , 255
   Circle(centrex , Centrey) , Radius , 255

   ' Stunden eintragen
   For K = 0 To 360 Step 30
    Angle_rad = Angle - K
    Angle_rad = Angle_rad * Pirad
    Sinangle = Sin(angle_rad) : Cosangle = Cos(angle_rad)
    W = Radius * Cosangle
    Startx = Centrex + W
    W = Radius * Sinangle
    Starty = Centrey - W
    W = Bigradius * Cosangle
    Endx = Centrex + W
    W = Bigradius * Sinangle
    Endy = Centrey - W
    Startx = Round(startx) : Starty = Round(starty)
    Clockx = Int(startx) : Clocky = Int(starty)
    Endx = Round(endx) : Endy = Round(endy)
    Ax = Int(endx) : Ay = Int(endy)
    Line(clockx , Clocky) -(ax , Ay) , 255                  'sleppers
   Next
    K = 0

   'lschen
   Call Drawsecond(0 , Clocksec)
   Call Drawminute(0 , Clockmin)
   Call Drawhour(0 , Clockhour)

   'zeichnen
   Call Drawsecond(255 , Clocksec)
   Call Drawminute(255 , Clockmin)
   Call Drawhour(255 , Clockhour)
End Sub

Sub Drawsecond(byval Color As Byte , Byval Value As Byte)
   ' Sekundenzeiger

   If Color = 0 Then                                        ' Vorherigen Zeiger lschen
      W = Value - 1
   Else
      W = Value
   End If

   W = W * 6
   Angle_rad = Angle - W
   Angle_rad = Angle_rad * Pirad
   Sinangle = Sin(angle_rad) : Cosangle = Cos(angle_rad)
   W = Seconderadius * Cosangle
   Xseconde = Centrex + W
   W = Seconderadius * Sinangle
   Yseconde = Centrey - W
   Xseconde = Round(xseconde)
   Yseconde = Round(yseconde)
   Clockx = Int(xseconde)
   Clocky = Int(yseconde)
   Line(centrex , Centrey) -(clockx , Clocky) , Color
End Sub

Sub Drawminute(byval Color As Byte , Byval Value As Byte)
   ' Minutenzeiger

   If Color = 0 Then                                        ' Vorherigen Zeiger lschen
      W = Value - 1
   Else
      W = Value
   End If

   W = W * 6
   Angle_rad = Angle - W
   Angle_rad = Angle_rad * Pirad
   Sinangle = Sin(angle_rad) : Cosangle = Cos(angle_rad)
   W = Minuteradius * Cosangle
   Xseconde = Centrex + W
   W = Minuteradius * Sinangle
   Yseconde = Centrey - W
   Xseconde = Round(xseconde)
   Yseconde = Round(yseconde)
   Clockx = Int(xseconde)
   Clocky = Int(yseconde)
   Line(centrex , Centrey) -(clockx , Clocky) , Color

   ' Etwas dicker zeichnen
   If Color = 0 Then                                        ' Vorherigen Zeiger lschen
      W = Value - 1
   Else
      W = Value
   End If

   W = W * 6
   W = W + 1
   Angle_rad = Angle - W
   Angle_rad = Angle_rad * Pirad
   Sinangle = Sin(angle_rad) : Cosangle = Cos(angle_rad)
   W = Minuteradius * Cosangle
   Xseconde = Centrex + W
   W = Minuteradius * Sinangle
   Yseconde = Centrey - W
   Xseconde = Round(xseconde)
   Yseconde = Round(yseconde)
   Clockx = Int(xseconde)
   Clocky = Int(yseconde)
   Line(centrex , Centrey) -(clockx , Clocky) , Color

   If Color = 0 Then                                        ' Vorherigen Zeiger lschen
      W = Value - 1
   Else
      W = Value
   End If

   W = W * 6
   W = W - 1
   Angle_rad = Angle - W
   Angle_rad = Angle_rad * Pirad
   Sinangle = Sin(angle_rad) : Cosangle = Cos(angle_rad)
   W = Minuteradius * Cosangle
   Xseconde = Centrex + W
   W = Minuteradius * Sinangle
   Yseconde = Centrey - W
   Xseconde = Round(xseconde)
   Yseconde = Round(yseconde)
   Clockx = Int(xseconde)
   Clocky = Int(yseconde)
   Line(centrex , Centrey) -(clockx , Clocky) , Color
End Sub

Sub Drawhour(byval Color As Byte , Byval Value As Byte)
   ' Stundenzeiger

   If Color = 0 Then                                        ' Vorherigen Zeiger lschen
      W = Value - 1
   Else
      W = Value
   End If

   W = W * 30
   Angle_rad = Angle - W
   Angle_rad = Angle_rad * Pirad
   Sinangle = Sin(angle_rad) : Cosangle = Cos(angle_rad)
   W = Hourradius * Cosangle
   Xseconde = Centrex + W
   W = Hourradius * Sinangle
   Yseconde = Centrey - W
   Xseconde = Round(xseconde)
   Yseconde = Round(yseconde)
   Clockx = Int(xseconde)
   Clocky = Int(yseconde)
   Line(centrex , Centrey) -(clockx , Clocky) , Color

   ' Etwas dicker zeichnen
   If Color = 0 Then                                        ' Vorherigen Zeiger lschen
      W = Value - 1
   Else
      W = Value
   End If

   W = W * 30
   W = W + 1
   Angle_rad = Angle - W
   Angle_rad = Angle_rad * Pirad
   Sinangle = Sin(angle_rad) : Cosangle = Cos(angle_rad)
   W = Hourradius * Cosangle
   Xseconde = Centrex + W
   W = Hourradius * Sinangle
   Yseconde = Centrey - W
   Xseconde = Round(xseconde)
   Yseconde = Round(yseconde)
   Clockx = Int(xseconde)
   Clocky = Int(yseconde)
   Line(centrex , Centrey) -(clockx , Clocky) , Color

   If Color = 0 Then                                        ' Vorherigen Zeiger lschen
      W = Value - 1
   Else
      W = Value
   End If

   W = W * 30
   W = W - 1
   Angle_rad = Angle - W
   Angle_rad = Angle_rad * Pirad
   Sinangle = Sin(angle_rad) : Cosangle = Cos(angle_rad)
   W = Hourradius * Cosangle
   Xseconde = Centrex + W
   W = Hourradius * Sinangle
   Yseconde = Centrey - W
   Xseconde = Round(xseconde)
   Yseconde = Round(yseconde)
   Clockx = Int(xseconde)
   Clocky = Int(yseconde)
   Line(centrex , Centrey) -(clockx , Clocky) , Color
End Sub
#endif