'routines for basic networking



' Routine for the ARP-Reply

Sub Arpreply
'Print " ARP ANFRAGE "
   'The original request packet is in the buffer, we just change some things
   'Swap MAC addresses
   Call Src2dest
   'Set source MAC in ethernet frame, pos 7
   Call Src2mymac
   'Copy target MAC in ARP packet
   T_arp_dest_enetpacket0 = T_enetpacketdest0
   T_arp_dest_enetpacket1 = T_enetpacketdest1
   T_arp_dest_enetpacket2 = T_enetpacketdest2
   T_arp_dest_enetpacket3 = T_enetpacketdest3
   T_arp_dest_enetpacket4 = T_enetpacketdest4
   T_arp_dest_enetpacket5 = T_enetpacketdest5
   'Set target IP in ARP packet
   T_arp_tipaddr0 = T_arp_sipaddr0
   T_arp_tipaddr1 = T_arp_sipaddr1
   T_arp_tipaddr2 = T_arp_sipaddr2
   T_arp_tipaddr3 = T_arp_sipaddr3
   'Copy source MAC to ARP
   T_arp_src_enetpacket0 = T_enetpacketsrc0
   T_arp_src_enetpacket1 = T_enetpacketsrc1
   T_arp_src_enetpacket2 = T_enetpacketsrc2
   T_arp_src_enetpacket3 = T_enetpacketsrc3
   T_arp_src_enetpacket4 = T_enetpacketsrc4
   T_arp_src_enetpacket5 = T_enetpacketsrc5
   'Set source IP to ARP packet pos 29
   T_arp_sipaddr0 = Myip(1)
   T_arp_sipaddr1 = Myip(2)
   T_arp_sipaddr2 = Myip(3)
   T_arp_sipaddr3 = Myip(4)
   'Set ARP type from Request to Reply
   T_arp_op1 = 2
   'Send the reply packet
   Call Enc28j60packetsend(42)
End Sub


' Routine for the Ping-Reply

Sub Pingreply
Print "PING ANFRAGE"
   'Local Packetlength As Word
   Packetlength = Buffer(17) * 256
   Packetlength = Packetlength + Buffer(18)
   'We are going to calculate the checksum till the end of packet (IP length + 14 byte of the ethernet stuff), -1 to get word start
   Packetlength = Packetlength + 13
   'set echo reply
   T_icmp_type = &H00
   T_icmp_code = &H00
   'setup the IP-header
   Call Setipaddrs
   Call Icmp_checksum
   Packetlength = Packetlength + 1
   'Send the reply packet
   Call Enc28j60packetsend(packetlength)
End Sub


Sub Setip_id
   Buffer(19) = High(ip_id)
   Buffer(20) = Low(ip_id)
   Ip_id = Ip_id + 1
End Sub



' Routine to calculate a IP-header checksum
'
Sub Ip_header_checksum
  Local Ip_checksum16 As Word
  Local Ip_header_length As Byte
  T_ip_hdr_cksum = &H00                                     'Calc starts with chksum=0
  'Calculate IP header length
  Ip_header_length = T_ip_vers_len And &H0F                 'Number of 32 bit words
  Ip_header_length = 4 * Ip_header_length                   'Calc number of bytes
  Ip_checksum16 = Tcpchecksum(buffer(15) , Ip_header_length )
  'Store the checksum value in the packet buffer
  T_ip_hdr_cksum1 = High(ip_checksum16)
  T_ip_hdr_cksum0 = Low(ip_checksum16)
End Sub


' Routine to calculate a ICMP-checksum
'
Sub Icmp_checksum
  'Clear the ICMP checksum before starting calculation
  T_icmp_cksum = &H00
  'Calculate the ICMP checksum
  I_header_length = T_ip_pktlen1 - 20
  I_checksum16 = Tcpchecksum(buffer(35) , I_header_length ) 'built-in way
  T_icmp_cksum1 = High(i_checksum16)
  T_icmp_cksum0 = Low(i_checksum16)
End Sub


' Routine to echo packet
'
Sub Echopacket
   'packetlengte
   Hulp2 = T_udp_len0 * 256
   Hulp2 = Hulp2 + T_udp_len1
   Hulp2 = Hulp2 + 34
   Call Enc28j60packetsend(hulp2)
End Sub


' Routine to handle the source/destination address
'
Sub Setipaddrs
   T_ip_destaddr = T_ip_srcaddr
   'make ethernet module IP address source address
   T_ip_srcaddr = My_ip
   Call Src2dest
   'Set source MAC in ethernet frame, pos 7
   Call Src2mymac
   Call Ip_header_checksum
End Sub


'Tcp-checksum
'
Sub Tcp_checksum
   Local Whulp1 As Word
   Local Tempword2 As Word
   Local Val1 As Word
   Local Val2 As Word
   Tcp_cksum = 0
   Call Srcdestchksum
   'resultaat in I_chksum32
   Tempwordh = T_ip_pktlen0
   Tempwordl = T_ip_pktlen1
   I_chksum32 = I_chksum32 + Tempword
   Tempword2 = T_ip_vers_len And &H0F
   Tempword2 = Tempword2 * 4
   I_chksum32 = I_chksum32 - Tempword2
   Whulp1 = Tempword - 20
   Val2 = Highw(i_chksum32)
   Val1 = I_chksum32
   I_checksum16 = Tcpchecksum(buffer(&H23) , Whulp1 , Val2 , Val1)
   Tcp_cksuml = High(i_checksum16)
   Tcp_cksumh = Low(i_checksum16)
End Sub


' Routine to calculate the IP-checkum
'
Sub Udp_checksum
   Local Val1 As Word
   Local Val2 As Word
   T_udp_chksum = &H00
   Call Srcdestchksum
   'resultaat in I_chksum32
   'packet length
   I_value16h = T_udp_len0
   I_value16l = T_udp_len1
   I_chksum32 = I_chksum32 + I_value16
   Result16h = T_udp_len0
   Result16l = T_udp_len1

   Val2 = Highw(i_chksum32)
   Val1 = I_chksum32

   I_checksum16 = Tcpchecksum(buffer(&H23) , Result16 , Val1 , Val2)

   T_udp_chksum1 = High(i_checksum16)
   T_udp_chksum0 = Low(i_checksum16)
End Sub


'****************************  routines to build the frame *********************


Sub Srcdestchksum
   'checksum TCP header
   I_chksum32 = 0
   I_value16h = T_ip_srcaddr0
   I_value16l = T_ip_srcaddr1
   I_chksum32 = I_chksum32 + I_value16
   I_value16h = T_ip_srcaddr2
   I_value16l = T_ip_srcaddr3
   I_chksum32 = I_chksum32 + I_value16
   I_value16h = T_ip_destaddr0
   I_value16l = T_ip_destaddr1
   I_chksum32 = I_chksum32 + I_value16
   I_value16h = T_ip_destaddr2
   I_value16l = T_ip_destaddr3
   I_chksum32 = I_chksum32 + I_value16
   'proto
   I_chksum32 = I_chksum32 + T_ip_proto
End Sub


Sub Inc2seq
    Incoming_ack0 = Tcp_seqnum0
    Incoming_ack1 = Tcp_seqnum1
    Incoming_ack2 = Tcp_seqnum2
    Incoming_ack3 = Tcp_seqnum3
End Sub


Sub Seq2ack
    Tcp_seqnum0 = Tcp_acknum0
    Tcp_seqnum1 = Tcp_acknum1
    Tcp_seqnum2 = Tcp_acknum2
    Tcp_seqnum3 = Tcp_acknum3
End Sub


Sub Ack2inc
    Tcp_acknum0 = Incoming_ack0
    Tcp_acknum1 = Incoming_ack1
    Tcp_acknum2 = Incoming_ack2
    Tcp_acknum3 = Incoming_ack3
End Sub


Sub Src2mymac
   'Make ethernet module mac address the source address
   T_enetpacketsrc0 = Mymac(1)
   T_enetpacketsrc1 = Mymac(2)
   T_enetpacketsrc2 = Mymac(3)                              'Buffer(7-12)
   T_enetpacketsrc3 = Mymac(4)
   T_enetpacketsrc4 = Mymac(5)
   T_enetpacketsrc5 = Mymac(6)
End Sub


Sub Src2dest
   'move hardware source address to destination address
   T_enetpacketdest0 = T_enetpacketsrc0
   T_enetpacketdest1 = T_enetpacketsrc1
   T_enetpacketdest2 = T_enetpacketsrc2
   T_enetpacketdest3 = T_enetpacketsrc3
   T_enetpacketdest4 = T_enetpacketsrc4
   T_enetpacketdest5 = T_enetpacketsrc5
   Call Src2mymac
End Sub


Sub Ack2tcp_ack
   Tcp_acknum3 = Acknum0
   Tcp_acknum2 = Acknum1
   Tcp_acknum1 = Acknum2
   Tcp_acknum0 = Acknum3
End Sub


Sub Seq2tcp_seq
   Tcp_seqnum3 = Seqnum0
   Tcp_seqnum2 = Seqnum1
   Tcp_seqnum1 = Seqnum2
   Tcp_seqnum0 = Seqnum3
End Sub


Sub Swapsrc2dest
   Swap T_enetpacketdest0 , T_enetpacketsrc0
   Swap T_enetpacketdest1 , T_enetpacketsrc1
   Swap T_enetpacketdest2 , T_enetpacketsrc2
   Swap T_enetpacketdest3 , T_enetpacketsrc3
   Swap T_enetpacketdest4 , T_enetpacketsrc4
   Swap T_enetpacketdest5 , T_enetpacketsrc5
End Sub


Sub Swapdestport2srcport
    Swap Tcp_srcporth , Tcp_destporth
    Swap Tcp_srcportl , Tcp_destportl
End Sub


Sub Clearbuff

  Local Xx As Word
  For Xx = 1 To Max_framelen
   Buffer(xx) = 0
  Next X

End Sub