Sub Enc28j60_reset
   Enc28j60_cs = 0
   'reset ENC28J60
   X = Enc28j60_soft_reset
   Spiout X , 1
   Enc28j60_cs = 1
   Do
   Call Enc28j60readcontrolregbyte(estat)
   X = Enc28j60_data.estat_clkrdy
   Loop Until X = 1
End Sub


Sub Enc28j60_setextclock
   'clock from default divide/4 (6.25 Mhz) to divide/2 (12.5 Mhz)
   Call Enc28j60writecontrolregbyte(ecocon , &B00000010)
   Waitms 250

End Sub


Function Enc28j60_version() As Byte
   Call Enc28j60selectbank(3)
   'EREVID
   A(1) = &B000_10010
   Enc28j60_cs = 0
   Spiout A(1) , 1
   Spiin A(1) , 2
   Enc28j60_cs = 1
   Enc28j60_version = A(2)
End Function

Sub Enc28j60_init
   'do bank 0 stuff
   'initialize receive buffer
   '16-bit transfers, must write low byte first
   'set receive buffer start address
   Nextpacketptr = Rxstart_init
   Value = Low(rxstart_init)
   Call Enc28j60writecontrolregbyte(erxstl , Value)
   Value = High(rxstart_init)
    Call Enc28j60writecontrolregbyte(erxsth , Value)
    'set receive pointer address
    Value = Low(rxstart_init)
    Call Enc28j60writecontrolregbyte(erxrdptl , Value)
    Value = High(rxstart_init)
    Call Enc28j60writecontrolregbyte(erxrdpth , Value)
    'set receive buffer end
    Value = Low(rxstop_init)
    Call Enc28j60writecontrolregbyte(erxndl , Value)
    Value = High(rxstop_init)
    Call Enc28j60writecontrolregbyte(erxndh , Value)
    'set transmit buffer start
    Value = Low(txstart_init)
    Call Enc28j60writecontrolregbyte(etxstl , Value)
    Value = High(txstart_init)
    Call Enc28j60writecontrolregbyte(etxsth , Value)
    'do bank 2 stuff
    'enable MAC receive
    Value = 0
    Value.macon1_marxen = 1
    Value.macon1_txpaus = 1
    Value.macon1_rxpaus = 1
    Call Enc28j60writecontrolregbyte(macon1 , Value)
    'bring MAC out of reset
    'enable automatic padding and CRC operations
    Value = 0
    Value.macon3_padcfg0 = 1
    Value.macon3_txcrcen = 1
    Value.macon3_frmlnen = 1
    Call Enc28j60writecontrolregbyte(macon3 , Value)
    'set inter-frame gap (non-back-to-back)
    Call Enc28j60writecontrolregbyte(maipgl , &H12)
    Call Enc28j60writecontrolregbyte(maipgh , &H0C)
    'set inter-frame gap (back-to-back)
    Call Enc28j60writecontrolregbyte(mabbipg , &H12)
    'set the maximum packet size which the controller will accept
    Value = Low(max_framelen)
    Call Enc28j60writecontrolregbyte(mamxfll , Value)
    Value = High(max_framelen)
    Call Enc28j60writecontrolregbyte(mamxflh , Value)

    'bank 3 stuff
    Call Enc28j60writecontrolregbyte(maadr5 , Mymac(1))
    Call Enc28j60writecontrolregbyte(maadr4 , Mymac(2))
    Call Enc28j60writecontrolregbyte(maadr3 , Mymac(3))
    Call Enc28j60writecontrolregbyte(maadr2 , Mymac(4))
    Call Enc28j60writecontrolregbyte(maadr1 , Mymac(5))
    Call Enc28j60writecontrolregbyte(maadr0 , Mymac(6))
    'no loopback of transmitted frames
    Call Enc28j60writephyword(phcon2 , Phcon2_hdldis)
    'switch to bank 0
    Call Enc28j60selectbank(0)
    'enable interrupts
    Value = 0
    Value.eie_intie = 1
    Value.eie_pktie = 1
    Call Enc28j60bitfield_set(eie , Value)
    'enable interrupt pin
    Call Enc28j60writecontrolregbyte(eie , &HC0)            'enable interrupt pin if a packet is received


    'filters according to Guido
    Call Enc28j60writecontrolregbyte(epmm0 , &H3F)
    Call Enc28j60writecontrolregbyte(epmm1 , &H30)
    Call Enc28j60writecontrolregbyte(epmcsl , &HF9)
    Call Enc28j60writecontrolregbyte(epmcsh , &HF7)

    Value = 0
    Value.erxfcon_pmen = 1                                  'Pattern Match enable (ARP only)
    Value.erxfcon_ucen = 1                                  'Unicast enable
    Call Enc28j60bitfield_set(erxfcon , Value)

    Value = 0
    Value.erxfcon_bcen = 0                                  '0 = Broadcast enable --> needed for DHCP
    Call Enc28j60bitfield_clear(erxfcon , Value)
    'CRC check is enabled by default

    'Something is wrong with the Broadcast filter (or the whole theory), it seems
    'like every packet is coming in

    'enable packet reception
    Value = 0
    Value.econ1_rxen = 1
    Call Enc28j60bitfield_set(econ1 , Value)

    'Reset transmit logic
    Value = 0
    Value.econ1_txrst = 1
    Call Enc28j60bitfield_set(econ1 , Value)
    Call Enc28j60bitfield_clear(econ1 , Value)
 End Sub


Sub Enc28j60selectbank(bank As Byte)
   'get ECON1 (BSEL1 en BSEL0)
   A(1) = &B000_11111
   Enc28j60_cs = 0
   Spiout A(1) , 1
   Spiin A(1) , 2
   Enc28j60_cs = 1
   A(2) = A(2) And &B1111_1100                              'strip bank part
   A(2) = A(2) Or Bank
   A(1) = &B010_11111
   Enc28j60_cs = 0
   Spiout A(1) , 2
   Enc28j60_cs = 1
End Sub


Sub Enc28j60writecontrolregbyte(register As Byte , Value As Byte)
   Bank = 0
   If Register.7 = 1 Then Bank = 2
   If Register.6 = 1 Then Bank = Bank + 1
   Register = Register And &B00011111
   Call Enc28j60selectbank(bank)
   Register.6 = 1                                           'to get a 010_register
   A(1) = Register
   A(2) = Value
   Enc28j60_cs = 0
   Spiout A(1) , 2
   Enc28j60_cs = 1
End Sub


Sub Enc28j60readcontrolregbyte(register As Byte)
   Local Mcphy As Byte
   Bank = 0
   Mcphy = 0
   If Register.7 = 1 Then Bank = 2
   If Register.6 = 1 Then Bank = Bank + 1
   If Register.5 = 1 Then Mcphy = 1
   Register = Register And &B00011111
   Call Enc28j60selectbank(bank)
   A(1) = Register
   Enc28j60_cs = 0
   Spiout A(1) , 1
   Spiin A(1) , 3
   Enc28j60_cs = 1
   'Depending of register (E, MAC, MII) yes or no dummybyte
   If Mcphy = 1 Then
      Enc28j60_data = A(2)
      Else
      Enc28j60_data = A(1)                                  '1.11.9.3  A(1) not A(3)
   End If
End Sub


Sub Enc28j60bitfield_set(register As Byte , Value As Byte)
   Bank = 0
   If Register.7 = 1 Then Bank = 2
   If Register.6 = 1 Then Bank = Bank + 1
   Register = Register And &B00011111
   Call Enc28j60selectbank(bank)
   Register = Register Or &B100_00000
   A(1) = Register
   A(2) = Value
   Enc28j60_cs = 0
   Spiout A(1) , 2
   Enc28j60_cs = 1
End Sub


Sub Enc28j60bitfield_clear(register As Byte , Value As Byte)
   Bank = 0
   If Register.7 = 1 Then Bank = 2
   If Register.6 = 1 Then Bank = Bank + 1
   Register = Register And &B00011111
   Call Enc28j60selectbank(bank)
   Register = Register Or &B101_00000
   A(1) = Register
   A(2) = Value
   Enc28j60_cs = 0
   Spiout A(1) , 2
   Enc28j60_cs = 1
End Sub


Sub Enc28j60readphyword(phyregister As Byte)
   'set the right address and start the register read operation
   Call Enc28j60writecontrolregbyte(miregadr , Phyregister)
   Call Enc28j60writecontrolregbyte(micmd , Micmd_miird)
   'wait until the PHY read complets
   Do
   Call Enc28j60readcontrolregbyte(mistat)
   Loop Until Enc28j60_data.mistat_busy = 0
   'quit reading
   Call Enc28j60writecontrolregbyte(micmd , 0)
   'get data value
   Call Enc28j60readcontrolregbyte(mirdl)
   Wdata = Enc28j60_data
   Shift Wdata , Left , 8
   Call Enc28j60readcontrolregbyte(mirdh)
   Wdata = Wdata + Enc28j60_data
End Sub


Sub Enc28j60writephyword(phyregister As Byte , Wdata As Word)
   Call Enc28j60readphyword(phyregister)
   Local Temp As Byte
   'set the PHY register address
   Call Enc28j60writecontrolregbyte(miregadr , Phyregister)
   Call Enc28j60readcontrolregbyte(miregadr)
   Temp = Miregadr
   Value = Low(wdata)
   Call Enc28j60writecontrolregbyte(miwrl , Value)
   Value = High(wdata)
   Call Enc28j60writecontrolregbyte(miwrh , Value)
   Do
   Call Enc28j60readcontrolregbyte(mistat)
   Loop Until Enc28j60_data.mistat_busy = 0
End Sub


Sub Enc28j60packetreceive

   Local Wtemp As Word

   'set the read pointer to the start of the received packet
   Value = Low(nextpacketptr)
   Call Enc28j60writecontrolregbyte(erdptl , Value)
   Value = High(nextpacketptr)
   Call Enc28j60writecontrolregbyte(erdpth , Value)
    Enc28j60_cs = 0
    'Send Read Buffer Memory command
    Spdr = &H3A
    Do
      '************** fr M32 und M644 ***********
    #if _chip = 23
         Loop Until Spsr.spif = 1
    #else
      Loop Until Spsr.spif0 = 1
    #endif                                                  '

          'Loop Until Spsr.spif0 = 1                         'SPI ready
    '************** fr M32 und M644 ***********

    'Get the first 6 byte (3 word: Nextpacketptr, Packetlength, Rxstat)
    For X = 1 To 6
          Spdr = &HFF                                       'SPI read
          Do
             '************** fr M32 und M644 ***********
    #if _chip = 23
         Loop Until Spsr.spif = 1
    #else
      Loop Until Spsr.spif0 = 1
    #endif                                                  '

          'Loop Until Spsr.spif0 = 1                         'SPI ready
    '************** fr M32 und M644 ***********

          Buffer(x) = Spdr
    Next X
    Nextpacketptr = Buffer(2) * 256
    Nextpacketptr = Nextpacketptr + Buffer(1)
    Length = Buffer(4) * 256
    Length = Length + Buffer(3)
    Rxstat = Buffer(6) * 256
    Rxstat = Rxstat + Buffer(5)
    'Get the payload
    Length = Length - 4                                     'Discard CRC
    For X = 1 To Length
          Spdr = &HFF                                       'SPI read
          Do
             '************** fr M32 und M644 ***********
    #if _chip = 23
         Loop Until Spsr.spif = 1
    #else
      Loop Until Spsr.spif0 = 1
    #endif                                                  '

          'Loop Until Spsr.spif0 = 1                         'SPI ready
    '************** fr M32 und M644 ***********

          Buffer(x) = Spdr
    Next X
    Enc28j60_cs = 1
   'move the rx read pointer to the start of the next received packet
   'this frees the memory we just read out
   Value = Low(nextpacketptr)
   Call Enc28j60writecontrolregbyte(erxrdptl , Value)
   Value = High(nextpacketptr)
   Call Enc28j60writecontrolregbyte(erxrdpth , Value)
   'decrement the packet counter indicate we are done with this packet
   Value = 0
   Value.econ2_pktdec = 1
   Call Enc28j60bitfield_set(econ2 , Value)


    'Handle the packet
    If Buffer(13) = &H08 Then

      If Buffer(14) = &H06 Then                             'Type:ARP
         If Buffer(21) = &H00 Then                          'ARP request
            If Buffer(22) = &H01 Then                       'ARP request
              If Buffer(39) = Myip(1) Then                  'ARP for us
                If Buffer(40) = Myip(2) Then
                   If Buffer(41) = Myip(3) Then
                      If Buffer(42) = Myip(4) Then
                        Call Arpreply
                      End If
                   End If
                End If
              End If
            End If
         End If
      End If

      If Buffer(14) = &H00 Then                             'Type:IP
         If Buffer(15) = &H45 Then                          'We handle only simple IP packets
            'If Buffer(21) = 0 Then                          'We handle only non fragmented packets


              If Buffer(31) = Myip(1) Then                  'Ip packet for us
                If Buffer(32) = Myip(2) Then
                   If Buffer(33) = Myip(3) Then
                      If Buffer(34) = Myip(4) Then

                        If Buffer(24) = Prot_icmp Then      'Protocol:ICMP
                           If Buffer(35) = &H08 Then        'ICMP echo request
                             Call Pingreply
                           End If
                        End If
                        If Buffer(24) = Prot_udp Then       'Protocol:UDP
                           Call Udp_receive
                        End If
                        If Buffer(24) = Prot_tcp Then       'Protocol:TCP
                           Call Tcp
                        End If

                      End If
                   End If
                End If
              End If


              If Buffer(31) = 255 Then                      'Ip broadcast
                 If Buffer(32) = 255 Then
                    If Buffer(33) = 255 Then
                       If Buffer(34) = 255 Then
                          If Buffer(24) = Prot_udp Then     'Protocol:UDP
                            Call Udp_receive
                         End If
                    End If
                 End If
               End If
             End If


          'End If
       End If
     End If

  End If



End Sub


Sub Enc28j60packetsend(pcktlen As Word)
   'Load packet into the ENC
   Enc28j60_cs = 0
   Spdr = Enc28j60_write_buf_mem
   Do
      '************** fr M32 und M644 ***********
    #if _chip = 23
         Loop Until Spsr.spif = 1
    #else
      Loop Until Spsr.spif0 = 1
    #endif                                                  '

          'Loop Until Spsr.spif0 = 1                         'SPI ready
    '************** fr M32 und M644 ***********

   Spdr = &B000_1110                                        'per packet byte
   Do
      '************** fr M32 und M644 ***********
    #if _chip = 23
         Loop Until Spsr.spif = 1
    #else
      Loop Until Spsr.spif0 = 1
    #endif                                                  '

          'Loop Until Spsr.spif0 = 1                         'SPI ready
    '************** fr M32 und M644 ***********

   For X = 1 To Pcktlen
      Spdr = Buffer(x)
      Do
         '************** fr M32 und M644 ***********
    #if _chip = 23
         Loop Until Spsr.spif = 1
    #else
      Loop Until Spsr.spif0 = 1
    #endif                                                  '

          'Loop Until Spsr.spif0 = 1                         'SPI ready
    '************** fr M32 und M644 ***********

   Next X
   Enc28j60_cs = 1
   'Minimum packet length is 60
   If Pcktlen < 60 Then Pcktlen = 60
   'Reset transmit logic
   Value = 0
   Value.econ1_txrst = 1
   Call Enc28j60bitfield_set(econ1 , Value)
   Call Enc28j60bitfield_clear(econ1 , Value)
   'set the write pointer to start of transmit buffer area
   Value = Low(txstart_init)
   Call Enc28j60writecontrolregbyte(ewrptl , Value)
   Value = High(txstart_init)
   Call Enc28j60writecontrolregbyte(ewrpth , Value)
   'set the TXND pointer to correspond to the packet size given
   Value = Low(txstart_init)
   Value = Value + Low(pcktlen)
   Call Enc28j60writecontrolregbyte(etxndl , Value)
   Value = High(txstart_init)
   Value = Value + High(pcktlen)
   Call Enc28j60writecontrolregbyte(etxndh , Value)
   'write per-packet control byte has been put in the writeroutine
   'send the contents of the transmit buffer onto the network
   Value = 0
   Value.econ1_txrts = 1
   Call Enc28j60bitfield_set(econ1 , Value)
End Sub